package dev.luminous.mod.modules.impl.combat;

import dev.luminous.api.utils.entity.EntityUtil;
import dev.luminous.api.utils.entity.InventoryUtil;
import dev.luminous.api.utils.world.BlockUtil;
import dev.luminous.mod.modules.Module;
import dev.luminous.mod.modules.impl.player.PacketMine;
import dev.luminous.mod.modules.settings.impl.BooleanSetting;
import dev.luminous.mod.modules.settings.impl.EnumSetting;
import net.minecraft.block.Blocks;
import net.minecraft.block.RespawnAnchorBlock;
import net.minecraft.item.Items;
import net.minecraft.util.math.BlockPos;

public class AntiAnchor extends Module {
    public static AntiAnchor INSTANCE;
    public final BooleanSetting onlyCharge = add(new BooleanSetting("OnlyCharge", true));
    public final BooleanSetting eatingPause = add(new BooleanSetting("EatingPause", false));
    public final BooleanSetting inventorySwap = add(new BooleanSetting("InventorySwap", true));
    public enum Mode {
        mineHead,
        eatRun
    }
    EnumSetting<AntiAnchor.Mode> mode = add(new EnumSetting<>("Mode", AntiAnchor.Mode.mineHead));
    private boolean hasEat = false;
    private int oldSlot = -1;
    private int chorus = -1;


    public AntiAnchor() {
        super("AntiAnchorTrap", Category.Combat);
        setChinese("反重生锚盖头");
        INSTANCE = this;
    }

    @Override
    public void onUpdate() {
        BlockPos pos = mc.player.getBlockPos().up(2);
        if (pos.equals(PacketMine.getBreakPos())) return;;
        if (eatingPause.getValue() && mc.player.isUsingItem()) return;
        if (mode.is(Mode.mineHead)){
            mineHead(pos);
        }
        else if (mode.is(Mode.eatRun)){
            eatRun(pos);
        }
    }

    private void eatRun(BlockPos pos) {
        if (BlockUtil.getBlock(pos) == Blocks.RESPAWN_ANCHOR && hasEat == false) {
            if (onlyCharge.getValue() && mc.world.getBlockState(pos).get(RespawnAnchorBlock.CHARGES) == 0) return;
            if (mc.player.getMainHandStack().getItem() == Items.CHORUS_FRUIT) {
                mc.options.useKey.setPressed(true);
            }
            else if (inventorySwap.getValue() && (chorus = InventoryUtil.findItemInventorySlot(Items.CHORUS_FRUIT)) != -1) {
                InventoryUtil.inventorySwap(chorus, mc.player.getInventory().selectedSlot);
                EntityUtil.syncInventory();
                mc.options.useKey.setPressed(true);
            }
            else if ((chorus = InventoryUtil.findItem(Items.CHORUS_FRUIT)) != -1) {
                oldSlot = mc.player.getInventory().selectedSlot;
                InventoryUtil.switchToSlot(chorus);
                mc.options.useKey.setPressed(true);
                EntityUtil.syncInventory();
            }
            hasEat = true;
        }
        else if (hasEat == true && BlockUtil.getBlock(pos)!= Blocks.RESPAWN_ANCHOR) {
            hasEat = false;
            mc.options.useKey.setPressed(false);
            if (inventorySwap.getValue()) {
                InventoryUtil.inventorySwap(chorus, mc.player.getInventory().selectedSlot);
            }
            else{
                InventoryUtil.switchToSlot(oldSlot);
            }
        }
    }

    private void mineHead(BlockPos pos) {
        if (BlockUtil.getBlock(pos) == Blocks.RESPAWN_ANCHOR) {
            if (onlyCharge.getValue() && mc.world.getBlockState(pos).get(RespawnAnchorBlock.CHARGES) == 0) return;;
            PacketMine.INSTANCE.mine(pos);
        }
    }
}